# Mechanizing Second-Order Logic in Coq

This directory contains the Coq formalization accompanying the Bachelor's thesis "Mechanizing Second-Order Logic in Coq".

Homepage of the project: https://www.ps.uni-saarland.de/~koch/bachelor.php

Browsable version available online: https://www.ps.uni-saarland.de/~koch/bachelor/coq/toc.html


## Building

The project is based on Coq 8.13.1 and requires the [Equations package](https://mattam82.github.io/Coq-Equation) (version 1.2.3).

To build the project, run `make` (takes around 5 minutes).


## Acknowledgement

* The files `ListLib.v`, `Decidable.v`, `Enumerable.v`, and `FOL.v` are based on the [Coq Library of Undecidability Proofs](https://github.com/uds-psl/coq-library-undecidability).

* The file `Util.v` contains proofs adapted from the [ICL 2020](https://courses.ps.uni-saarland.de/icl_20/2/Resources) and [ACT 2021](https://courses.ps.uni-saarland.de/atctt_20/) lectures.
